#!/usr/bin/env python
#
# Problem EPage 410 
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, sqrt, pi, sin, cos, zeros

# Constants of this problem:
# 
E = 120 
R_1 = 2
R_2 = 3.6
R_3 = 1.5
R_4 = 1.8
R_5 = 1.2

from gaussElimin import gaussElimin
from goldSearch import bracket, search

def f(R):
    """
    A function for minimization
    """
    # Form the matrix A and the right-hand-side b: 
    # 
    A = zeros( (2,2), dtype=float ) 
    A[0,0] = R_1 + R_3 + R 
    A[0,1] = -R
    A[1,0] = -R 
    A[1,1] = R_2 + R_4 + R_5 + R 
    b = zeros( (2,1), dtype=float ) 
    b[0] = E

    # Solve for [i_1,i_2]:
    # 
    gaussElimin(A,b) 

    # Compute the power dissipated by R:
    # 
    power_dissipated = R * ( b[1] - b[0] )**2 

    return -power_dissipated

xStart = 0.1
h = 0.01 
x1, x2 = bracket(f,xStart,h)
x, fMin = search(f,x1,x2)
print "x= ", x 
print "f(x)= ", fMin

if False: 
    xs = np.linspace( 0, 4, 200 ) 
    fs = [ f(_) for _ in xs ]
    import pylab
    pylab.plot( xs, fs )
    pylab.xlabel('R')
    pylab.ylabel('f')
    pylab.grid('on')
    pylab.show()

