#!/usr/bin/env python
#
# Problem EPage 62
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, dot, prod, diag, transpose 

from LUdecomp import LUdecomp, LUsolve

A_orig = asarray( [ [ 4, -3, 6 ], [ 8, -3, 10 ], [ -4, 12, -10 ] ], dtype=float ) 
A = A_orig.copy() 
B_orig = asarray( [ [ 1, 0 ], [ 0, 1 ], [ 0, 0 ] ], dtype=float )
B = B_orig.copy()

# Factor our system:
# 
LUdecomp(A)

x_1 = B[:,0].copy()
LUsolve(A,x_1)
print "Solution to Ax=B[:,0] is ", x_1
x_1.shape = (len(x_1),1)

x_2 = B[:,1].copy()
LUsolve(A,x_2)
print "Solution to Ax=B[:,1] is ", x_2
x_2.shape = (len(x_2),1)

X = np.hstack( (x_1,x_2) )
assert np.linalg.norm( dot(A_orig,X) - B_orig ) < 1.e-6

