#!/usr/bin/env python
#
# Problem EPage 106
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, dot, identity

from LUpivot import *

def matInv(a):
    n = a.shape[0]
    aInv = identity(n)
    a,seq = LUdecomp(a)
    for i in range(n):
        aInv[:,i] = LUsolve(a,aInv[:,i],seq)
    return aInv 

A = asarray( [ [ 1, 3, -9, 6, 4 ], [ 2, -1, 6, 7, 1 ], [ 3, 2, -3, 15, 5 ], [ 8, -1, 1, 4, 2 ], [ 11, 1, -2, 18, 7 ] ], dtype=float ) 
A_orig = A.copy()
aInv = matInv(A)
print "aInv= "
print aInv
print dot(aInv,A_orig)

# Lets look at the condition number of this matrix (we expect it to be large): 
print "cond(A)= ", np.linalg.cond(A_orig)

# Can numpy do a beter job at producing an inverse:
aInv_np = np.linalg.inv(A_orig)
print aInv_np
print dot(aInv_np,A_orig)

# We expect a very small determinant for this A: 
print "det(A)= ", np.linalg.det(A_orig)
