#!/usr/bin/env python
#
# Problem EPage 133
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import asarray, pi
import newtonPoly
from neville import neville
import cubicSpline 

# Our data:
# 
xData = asarray( [ 0, 0.0204, 0.1055, 0.241, 0.582, 0.712, 0.981 ] )
yData = asarray( [ 0.385, 1.04, 1.79, 2.63, 4.39, 4.99, 5.27 ] )

x_interp = 0.46

# Neville's interpolation:
# 
y_interp_neville = neville(xData,yData,x_interp)

# Cubic spline interpolation:
# 
k = cubicSpline.curvatures(xData,yData)
y_interp_spline = cubicSpline.evalSpline(xData,yData,k,x_interp) 

print "T= %10.6f; neville= %10.6f, spline= %10.6f" % (x_interp,y_interp_neville,y_interp_spline)








