#!/usr/bin/env python
#
# Problem EPage 133
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import asarray, pi, log, exp
import cubicSpline 

# Our data:
# 
xData = log( asarray( [ 0.2, 2, 20, 200, 2000, 20000 ] ) )
yData = log( asarray( [ 103, 13.9, 2.72, 0.800, 0.401, 0.433 ] ) )

for x_interp in log( asarray( [ 5, 50, 500, 5000 ] ) ): 
    # Cubic spline interpolation:
    # 
    k = cubicSpline.curvatures(xData,yData)
    y_interp_spline = cubicSpline.evalSpline(xData,yData,k,x_interp) 
    
    print "Re= %10.3f; spline= %10.6f" % (exp(x_interp),exp(y_interp_spline))






