#!/usr/bin/env python
#
# Problem EPage 131
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import asarray, pi
import newtonPoly
from neville import neville
import cubicSpline 

# Our data:
# 
xData = asarray( [ 0, 0.5, 1, 1.5, 2 ] )
yData = asarray( [ -0.7854, 0.6529, 1.7390, 2.2071, 1.9425 ] ) 

for x_interp in [ pi/4, pi/2 ]: 

    # A newton interpolating polynomial:
    # 
    a = newtonPoly.coeffts(xData,yData)
    y_interp_newton = newtonPoly.evalPoly(a,xData,x_interp)

    # Neville's interpolation:
    # 
    y_interp_neville = neville(xData,yData,x_interp)

    # Cubic spline interpolation:
    # 
    k = cubicSpline.curvatures(xData,yData)
    y_interp_spline = cubicSpline.evalSpline(xData,yData,k,x_interp) 
    
    print "x= %10.6f; newton= %10.6f, neville= %10.6f, spline= %10.6f" % (x_interp,y_interp_newton,y_interp_neville,y_interp_spline)






