#!/usr/bin/env python
#
# Problem EPage 149
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import asarray, log, exp
from polyFit import * 
from evalPoly import evalPoly 

# Our data:
# 
xData = asarray( [ 0.5, 1.0, 1.5, 2.0, 2.5 ] )
yData = asarray( [ 0.541, 0.398, 0.232, 0.106, 0.052 ] )

y_over_x_Data = yData / xData 

lyoxData = log( y_over_x_Data ) 

coeff = polyFit( xData, lyoxData, 1 )
print "coeff_hat= ", coeff
print "coeff= ", exp(coeff[0]), coeff[1]

a = exp(coeff[0])
b = coeff[1]

y_hat = a * xData * exp( b * xData ) # our model predictions 
residual = yData - y_hat 
S = sum( residual**2 )
n = len(xData) # I think that the "n" in the denominator of 3.15 (the equation for sigma in the book) should be "n+1"
sigma = sqrt( float(S) / ( n - 2 ) )
print "sigma= ", sigma 



