#!/usr/bin/env python
#
# Problem EPage 173
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import cos, sin, cosh, sinh, linspace, nan, pi, sqrt 
from newtonRaphson import *

def f(x): return cosh(x) * cos(x) + 1 
def df(x): return sinh(x) * cos(x) - cosh(x) * sin(x) 

if __name__ == "__main__":
    L = 0.9
    width = 25 * 1.e-3 # units of meters
    height = 2.5 * 1.e-3
    I = ( 1./12 ) * width * height**3 # moment of intertia 
    rho = 7850 
    V = L * width * height # volume 
    m = V * rho # mass of beam
    E = 200 * 1.e9 # modulus of elasticity 

    if True: 
        xs = linspace( 1, +6, 500 ) 
        fs = [ f(_) for _ in xs ]
    
        import pylab; 
        pylab.plot( xs, fs ); 
        pylab.xlabel('x'); pylab.ylabel('f(x)');
        pylab.hold('on')
        pylab.axhline(y=0,color='k')
        pylab.grid('on'); 
        pylab.show()
        
    firstRoot = newtonRaphson( f, df, 1.5, 2.5 )
    secondRoot = newtonRaphson( f, df, +4.0, 5.0 )

    # Given the roots compute the frequencies:
    # 
    C = ( ( 2 * pi )**2 * m * L**3 ) / ( E * I ) # all constanst now beta^4 = C f^2 
    f_1 = sqrt( ( firstRoot**4 ) / C ) 
    f_2 = sqrt( ( secondRoot**4 ) / C ) 

    print "f_1= ", f_1
    print "f_2= ", f_2


