#!/usr/bin/env python
#
# Problem EPage 173
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import cos, sin, tan, cosh, sinh, linspace, nan, pi, sqrt 
from newtonRaphson import *

def sec(x) : return 1./cos(x)
def f(x,C1,C2,sigma_max): return x * ( 1 + C1 * sec( C2 * sqrt(x) ) ) - sigma_max  
def df(x,C1,C2,sigma_max): return ( 1 + C1 * sec( C2 * sqrt(x) ) ) + x * C1 * sec( C2 * sqrt(x) ) * tan( C2 * sqrt(x) ) * C2 / ( 2 * sqrt(x) )

if __name__ == "__main__":
    mm_to_meters = 1.e-3
    A = 25800 * mm_to_meters**2 # all in units of meters 
    e = 85 * mm_to_meters 
    c = 170 * mm_to_meters 
    r = 142 * mm_to_meters 
    L = 7100 * mm_to_meters 
    E = 71 * 1.e9 # Pa 
    sigma_max = 120 * 1.e6

    C1 = e * c / r**2 
    C2 = L / ( 2 * r * sqrt(E) )
    print "C1, C2= ", C1, C2

    if True: 
        xs = linspace( 0, +150 * 1.e6, 500 ) 
        fs = [ f(_,C1,C2,sigma_max) for _ in xs ]
    
        import pylab; 
        pylab.plot( xs, fs ); 
        pylab.xlabel('x'); pylab.ylabel('f(x)');
        pylab.hold('on')
        pylab.axhline(y=0,color='k')
        pylab.grid('on'); 
        pylab.show()

    sigma_tilde = newtonRaphson( lambda _: f(_,C1,C2,sigma_max), lambda _: df(_,C1,C2,sigma_max), 0.4 * 1.e8, 0.8 * 1.e8 )
    print "sigma_tilde= ", sigma_tilde
