#!/usr/bin/env python
#
# Problem EPage 176
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import linspace, nan, sqrt, log
from newtonRaphson import *

def f(T,R,T0,G): return -R * T * ( 5./2 ) * log( T/T0 ) - G 
def df(T,R,T0,G): return -R * ( 5./2 ) * log( T/T0 ) - R * ( 5./2 ) * ( 1. / T )

if __name__ == "__main__":

    R = 8.31441 
    T0 = 4.44418
    G = -10 # units of kJ

    if True: 
        xs = linspace( 0.04, 3*T0, 500 )
        fs = [ f(_,R,T0,G) for _ in xs ]
    
        import pylab; 
        pylab.plot( xs, fs ); 
        pylab.xlabel('x'); pylab.ylabel('f(x)');
        pylab.hold('on')
        pylab.axhline(y=0,color='k')
        pylab.grid('on'); 
        pylab.show()

    T = newtonRaphson( lambda _: f(_,R,T0,G), lambda _: df(_,R,T0,G), 4, 6 )
    print "T= ", T
