#!/usr/bin/env python
#
# Problem EPage 176
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import linspace, nan, sqrt
from newtonRaphson2 import *

def y1(x): return sqrt( 4. - (x-2)**2 )
def y2(x,s=+1): return 3. + s * sqrt( 4. - x**2 )
def f(x) :
    f = zeros( (len(x)) )
    f[0] = (x[0] - 2)**2 + x[1]**2 - 4 
    f[1] = x[0]**2 + (x[1]-3)**2 - 4 
    return f
    

if __name__ == "__main__":

    if True:
        import pylab; 
        pylab.hold('on')
        pylab.grid('on')
        pylab.axis('equal')

        xs = linspace( 0.0, 4.0, 200 )

        y1s = [ y1(_) for _ in xs ]
        pylab.plot( xs, y1s, color='b' ); 

        y1s = [ -y1(_) for _ in xs ]
        pylab.plot( xs, y1s, color='b' ); 

        xs = linspace( -2.0, 2.0, 200 )

        y2s = [ y2(_) for _ in xs ]
        pylab.plot( xs, y2s, color='g' ); 

        y2s = [ y2(_,s=-1) for _ in xs ]
        pylab.plot( xs, y2s, color='g' ); 

        pylab.xlabel('x'); 
        pylab.axhline(y=0,color='k')
        pylab.axvline(x=0,color='k')
        pylab.show()

    print "Leftmost intersection= " ,
    print newtonRaphson2( f, [0.25,0.95] )

    print "Rightmost intersection= " ,
    print newtonRaphson2( f, [1.7,1.9] )
