#!/usr/bin/env python
#
# Problem EPage 176
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import linspace, asarray, nan, sqrt, cos, sin, tan, arcsin, pi, mean
from newtonRaphson2 import *

def f(x) :
    f = zeros( (len(x)) )
    f[0] = (8.21 - x[0])**2 + (0.0   - x[1])**2 - x[2]**2
    f[1] = (0.34 - x[0])**2 + (6.62  - x[1])**2 - x[2]**2
    f[2] = (5.96 - x[0])**2 + (-1.12 - x[1])**2 - x[2]**2
    return f
    

if __name__ == "__main__":
    # Pick a good initial starting value for (a,b,R): 
    #
    xs = [ 8.21, 0.34, 5.96 ] 
    ys = [ 0.0, 6.62, -1.12 ] 
    a0 = mean( xs )
    b0 = mean( ys )
    r0s = []
    for x,y in zip( xs, ys ): 
        r0s.append( sqrt( (x-a0)**2 + (y-b0)**2 ) )
    R0 = mean( r0s )
    print "a0, b0, R0= ",
    print [a0,b0,R0]
    print "a, b, R= ", 
    print newtonRaphson2( f, [a0,b0,R0] )
