#!/usr/bin/env python
#
# Problem EPage 178
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import empty, asarray, linspace, sin, pi, mean
from newtonRaphson2 import *

thetas = asarray( [ -30., 0., 30. ] ) * ( pi / 180. )
Rs = asarray( [ 6870., 6728., 6615. ] )

def f(x): 
    f = empty( (len(thetas)) )
    for _ in range(len(thetas)):
        f[_] = x[0] / ( 1. + x[1] * sin( thetas[_] + x[2] ) ) - Rs[_]
    return f 

if __name__ == "__main__":
    C0 = mean(Rs)
    e0 = mean( C0 / Rs ) - 1
    alpha0 = 0.
    x0 = [ C0, e0, alpha0 ] # initial values of C, e, and alpha 
    print "initial values of C,e,alpha= ", x0
    xN = newtonRaphson2( f, asarray( x0 ) )
    print "final values of C,e,alpha= ", xN
    C, e, alpha = xN

    theta_min = ( pi / 2 - alpha ) % ( 2 * pi ) 
    print "theta_1 (radians,degrees)= ", theta_min, theta_min * ( 180. / pi ) 

    theta_max = ( 3 * pi / 2 - alpha ) % ( 2 * pi ) 
    print "theta_2 (radians,degrees)= ", theta_max, theta_max * ( 180. / pi ) 

    # Plot R a a function of theta:
    # 
    thetas = linspace( 0, 2*pi, 100 )
    Rs = C / ( 1 + e * sin( thetas + alpha ) )

    import matplotlib.pyplot as plt 
    ax = plt.subplot( 111, polar=True )
    ax.hold('on')
    ax.plot( thetas, Rs, color='blue', linewidth=3 )
    ax.set_rmax(8000)
    ax.grid(True)
    plt.show()


