#!/usr/bin/env python
#
# Problem EPage 178
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import empty, asarray, cos, sin, pi
from newtonRaphson2 import *

theta_3 = 75. * ( pi / 180. )
 
def f(x): 
    theta_1, theta_2 = x 
    f = empty( (len(x)) ) 
    f[0] = 150 * cos( theta_1 ) + 180 * cos( theta_2 ) - 200 * cos( theta_3 ) - 200 
    f[1] = 150 * sin( theta_1 ) + 180 * sin( theta_2 ) - 200 * sin( theta_3 ) 
    return f 

if __name__ == "__main__":
    
    x0 = asarray( [ 75, 10 ] ) * ( pi / 180 ) 
    print "initial values of theta_1,theta_2 (degrees)= ", x0 * ( 180/pi ) 
    xN = newtonRaphson2( f, asarray( x0 ) )
    print "final values of theta_1,theta_2 (degrees)= ", xN * ( 180/pi ) 

    x0 = asarray( [ 10, 0.5 * ( 45 + 90 ) ] ) * ( pi / 180. )
    print "initial values of theta_1,theta_2 (degrees)= ", x0 * ( 180/pi ) 
    xN = newtonRaphson2( f, asarray( x0 ) )
    print "final values of theta_1,theta_2 (degrees)= ", xN * ( 180/pi )
    


