#!/usr/bin/env python
#
# Problem EPage 173
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import cos, sin, cosh, sinh, linspace
from rootsearch import *
from newtonRaphson import *

def f(x): return x**3 - 1.2 * x**2 - 8.19 * x + 13.23
def df(x): return 3 * x**2 - 2.4 * x - 8.19 

if __name__ == "__main__":
    if False: 
        xs = linspace( +1.5, +2.5, 500 ) 
        fs = [ f(_) for _ in xs ]
    
        import pylab; 
        pylab.plot( xs, fs ); 
        pylab.xlabel('x'); pylab.ylabel('f(x)');
        pylab.hold('on')
        pylab.axhline(y=0,color='k')
        pylab.grid('on'); 
        pylab.show()

    a, b = 1., 3.
    a, b = rootsearch( f, a, b, 0.1 )
    print "a, b (from rootsearch)= ", a, b
        
    root = newtonRaphson( f, df, a, b ) 
    print "root= ", root
    print "f(root)= ", f(root)


