#!/usr/bin/env python
#
# Problem EPage 239
# Table of Gauss-Legendre points on EPage 230
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import sqrt
from gaussQuad import *

def f(x,a,b): 
    numer = ( b * x )**2 
    denom = a**2 * ( a**2 - x**2 ) 
    return 2 * sqrt( 1 + numer / denom ) 

def GQ_integrate( a, b, m=2 ):
    """
    """
    return gaussQuad( lambda _ : f(_, a, b), -a, +a, m )

def compute_ellipse_circumference( a=2, b=1, tol=1.e-5, max_num_nodes=500 ):
    """
    """
    I_old = GQ_integrate( a, b, m=2 )
    for m in range(2+1,max_num_nodes+1):
        I_new = GQ_integrate( a, b, m=m )
        if abs( I_new - I_old ) < tol * max(abs(I_new),1.0) : 
            return I_new, m  
        I_old = I_new
    print "Gauss-Legendre did not converge to desired tolerance using fewer than %5d nodes" % max_num_nodes

if __name__ == "__main__":
    result = compute_ellipse_circumference()
    if result is not None : 
        print "I= %10.6f with m= %5d nodes" % (result[0],result[1])

