#!/usr/bin/env python
#
# Problem EPage 239
# Table of Gauss-Legendre points on EPage 230
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import sqrt
from gaussQuad import *

def f(z): return sqrt( (sqrt(2) - 1)**2 - ( sqrt(1+z**2) - 1 )**2 )

def compute_integral( tol=1.e-6, max_num_nodes=500 ):
    """
    """
    a, b = 0, 1 # limits of the integration 
    I_old = gaussQuad( f, a, b, 2 )
    for m in range(2+1,max_num_nodes+1):
        I_new = gaussQuad( f, a, b, m )
        if abs( I_new - I_old ) < tol * max(abs(I_new),1.0) : 
            return I_new, m  
        I_old = I_new
    print "Gauss-Legendre did not converge to desired tolerance using fewer than %5d nodes" % max_num_nodes

if __name__ == "__main__":
    print compute_integral()

