#!/usr/bin/env python
#
# Problem EPage 239
# Table of Gauss-Legendre points on EPage 230
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import pi, log, sin
from gaussQuad import *

def f(x): return log(sin(x)) 

def compute_integral( a, b, tol=1.e-7, max_num_nodes=500 ):
    """
    a, b are the limits of the integration 
    """
    I_old = gaussQuad( f, a, b, 2 )
    for m in range(2+1,max_num_nodes+1):
        I_new = gaussQuad( f, a, b, m )
        if abs( I_new - I_old ) < tol * max(abs(I_new),1.0) : 
            return I_new, m  
        I_old = I_new
    print "Gauss-Legendre did not converge to desired tolerance using fewer than %5d nodes" % max_num_nodes

if __name__ == "__main__":
    I_1 = 0.01 * log(0.01) - 0.01 # = -0.0560517
    I_2 = compute_integral(0.01,0.2)
    I_3 = compute_integral(0.2,pi/2)
    print "Integral Parts= ", I_1, I_2, I_3 
    print "Total Integral= ", I_1 + I_2[0] + I_3[0] 


