#!/usr/bin/env python
#
# Problem EPage 276
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import sin, asarray, zeros, interp
from run_kut4 import integrate
from printSoln import printSoln
import pylab 

g = 9.80665
a = 16.

def F(x,y): 
    F = zeros( (2,), dtype=float ) 
    F[0] = y[1]
    F[1] = g * ( 1 - a * y[0]**3 ) 
    return F

x0 = 0.0 # start of the integration 
xStop = 2.0 # end of the integration 
y0 = asarray( [ 0.1, 0. ], dtype=float ) 
h = 0.01
freq = 20

X,Y = integrate(F,x0,y0,xStop,h) 
#printSoln(X,Y,freq)

if True: 
    pylab.plot( X, Y[:,0] )
    pylab.xlabel('time (t)'); pylab.ylabel('y(t)');
    pylab.grid('on')
    pylab.show() 

