#!/usr/bin/env python
#
# Problem EPage 276
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import sin, cos, asarray, zeros, interp, pi 
from run_kut4 import integrate
from printSoln import printSoln
import pylab 

g = 9.80665

def F(x,y): 
    F = zeros( (2,), dtype=float ) 
    F[0] = y[1]
    F[1] = -(pi**2 / 12)**2 * y[0] * sin(pi * x)**2 - g * sin( (pi/12) * cos( pi * x ) ) 
    return F

x0 = 0.0 # start of the integration 
xStop = 40.0 # end of the integration 
y0 = asarray( [ 0.75, 0. ], dtype=float ) 
h = 0.01
freq = 20

X,Y = integrate(F,x0,y0,xStop,h) 
#printSoln(X,Y,freq)

if True:
    pylab.plot( X, Y[:,0] )
    pylab.xlabel('time (t)'); pylab.ylabel('r(t)');
    pylab.grid('on')
    pylab.show() 

