#!/usr/bin/env python
#
# Problem EPage 276
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, zeros, exp 
if True: 
    from run_kut4 import integrate
else:
    from run_kut5 import integrate
from printSoln import printSoln
import pylab 

def F(t,y): 
    # vector y is = [ y(t), y'(t) ]
    F = zeros( (2,), dtype=float ) 
    F[0] = y[1]
    F[1] = 16.81 * y[0]
    return F 

t0 = 0.0 # start of the integration 
tStop = 8.0 # end of the integration 
lambda_max = 4.1
h_max = 2./lambda_max 
print "h_max= %10.6f" % h_max 
h = 1.e-2 # enough smaller than h_max ... everything converges nicely 
h = 0.5 # larger than h_max ... everything diverges 
freq = 0

y0 = asarray( [ 1., -4.1 ], dtype=float ) 
T,Y = integrate(F,t0,y0,tStop,h) 
printSoln(T,Y,freq)

Y_truth = exp( -4.1 * T ) 

if True: 
    pylab.plot( T, Y[:,0], label='approx. sol.' )
    pylab.hold('on')
    pylab.plot( T, Y_truth, color='green', label='truth' )
    pylab.xlabel('t (time)'); pylab.ylabel('y(t)')
    pylab.grid('on')
    pylab.legend(loc='best')
    pylab.show() 
