#!/usr/bin/env python
#
# Problem EPage 299
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, zeros, sin, cos, tan, pi
from run_kut5 import integrate
from printSoln import printSoln
import pylab 

def cot(x): return 1./tan(x) 

def F(x,y): 
    theta, theta_dot, phi, phi_dot = y # vector y is = [ theta(t), theta'(t), phi(t), phi'(t) ] 
    F = zeros( (len(y),), dtype=float ) 
    F[0] = theta_dot
    F[1] = phi_dot**2 * sin(theta) * cos(theta) 
    F[2] = phi_dot
    F[3] = - 2 * theta_dot * phi_dot * cot(theta) 
    return F 

x0 = 0.0 # start of the integration 
xStop = 1.5 # end of the integration 
h = 0.1
freq = 0

y0 = asarray( [ pi/12, 0, 0, 20 ], dtype=float ) 
X,Y = integrate(F,x0,y0,xStop,h) 
printSoln(X,Y,freq)

if True: 
    pylab.plot( X, Y[:,3] )
    pylab.xlabel('t'); pylab.ylabel("phi'(t)")
    pylab.grid('on')
    pylab.axis('tight')
    pylab.show() 
