#!/usr/bin/env python
#
# Problem EPage 280
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, zeros, sin, cos, pi 
from run_kut5 import integrate
from printSoln import printSoln
import pylab 

R = 0.
L = 2
C = 0.45

def E(t): 
    if t < 0: 
        return 0.
    else: 
        return 9 * sin( pi * t ) 

def F(t,y): 
    q_of_t, i_of_t = y # vector y is = [ q(t), i(t) ]
    F = zeros( (len(y),), dtype=float ) 
    F[0] = i_of_t
    F[1] = ( -R * i_of_t - q_of_t / C + E(t) )/L
    return F 

t0 = 0.0 # start of the integration 
tStop = 10.0 # end of the integration 
h = 0.1
freq = 0

y0 = asarray( [ 0., 0. ], dtype=float ) 
T,Y = integrate(F,t0,y0,tStop,h) 
printSoln(T,Y,freq)

if True: 
    pylab.plot( T, Y[:,1], label='i(t)' )
    pylab.xlabel('t (time)')
    pylab.legend(loc='best')
    pylab.grid('on')
    pylab.axis('tight')
    pylab.show() 
