#!/usr/bin/env python
#
# Problem EPage 302
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, zeros, sin, cos, pi 
from run_kut5 import integrate
from printSoln import printSoln
import pylab 

R = 1.
L = 0.2 * 1.e-3
C = 3.5 * 1.e-3 

def E(t): return 240.
def dEdt(t): return 0.

def F(t,y): 
    i_1, i_2 = y # vector y is = [ i_1(t), i_2(t) ]
    F = zeros( (2,), dtype=float ) 
    F[0] = ( -3*R*i_1 - 2*R*i_2 + E(t) )/L
    F[1] = -(2./3) * F[0] - i_2/(3*R*C) + (1./(3*R)) * dEdt(t) 
    return F 

t0 = 0.0 # start of the integration 
tStop = 0.05 # end of the integration 
h = 0.01
freq = 0

y0 = asarray( [ 0., 0. ], dtype=float ) 
T,Y = integrate(F,t0,y0,tStop,h) 
printSoln(T,Y,freq)

if True: 
    pylab.plot( T, Y[:,0], label='i_1(t)' )
    pylab.hold('on')
    pylab.plot( T, Y[:,1], label='i_2(t)' )
    pylab.xlabel('t (time)')
    pylab.legend(loc='best')
    pylab.grid('on')
    pylab.axis('tight')
    pylab.show() 
