#!/usr/bin/env python
#
# Problem EPage 280
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, zeros, sin, cos, pi 
from run_kut5 import integrate
from printSoln import printSoln
import pylab 

a = 1.0 
b = 0.2

def F(t,y): 
    # the vector y is = [ y_0(t), y_1(t) ]
    y_0, y_1 = y
    F = zeros( (len(y),), dtype=float ) 
    F[0] = a * ( y_0 - y_0 * y_1 ) 
    F[1] = b * ( -y_1 + y_0 * y_1 ) 
    return F 

t0 = 0.0 # start of the integration 
tStop = 50.0 # end of the integration 
h = 1.e-1
freq = 0

y0 = asarray( [ 0.1, 1.0 ], dtype=float ) 
T,Y = integrate(F,t0,y0,tStop,h) 
printSoln(T,Y,freq)

if True: 
    pylab.plot( T, Y[:,0], label='y_0(t)' )
    pylab.hold('on')
    pylab.plot( T, Y[:,1], label='y_1(t)' )
    pylab.xlabel('t (time)')
    pylab.legend(loc='best')
    pylab.grid('on')
    pylab.axis('tight')
    pylab.show() 
