#!/usr/bin/env python
#
# Problem EPage 300
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, zeros, exp, dot
from run_kut5 import integrate
from printSoln import printSoln
from gaussElimin import gaussElimin 
import pylab 

def F(t,y): 
    # vector y is = [ y(t), y'(t) ]
    F = zeros( (2,), dtype=float ) 
    F[0] = y[1]
    F[1] = 16.81 * y[0]
    return F 

t0 = 0.0 # start of the integration 
tStop = 2.0 # end of the integration 
h = 1.e-2 
freq = 0

# Part (a): 
y0 = asarray( [ 1., -4.1 ], dtype=float ) 
T_a,Y_a = integrate(F,t0,y0,tStop,h) 
printSoln(T_a,Y_a,freq)

Y_truth_a = exp( -4.1 * T_a ) 

# Part (b): 
y0 = asarray( [ 1., -4.11 ], dtype=float ) 
T_b,Y_b = integrate(F,t0,y0,tStop,h) 
printSoln(T_b,Y_b,freq)

A_orig = asarray( [ [ 1, 1 ], [ -4.1, +4.1 ] ], dtype=float )
b_orig = asarray( [ 1, -4.11 ], dtype=float )
x_sol = b_orig.copy() 
gaussElimin(A_orig.copy(),x_sol)
print "x_sol= ", x_sol  
print np.linalg.norm( dot(A_orig,x_sol) - b_orig )
Y_truth_b = x_sol[0] * exp( -4.1 * T_b ) + x_sol[1] * exp( +4.1 * T_b ) 

if True: 
    pylab.hold('on')

    pylab.plot( T_a, Y_a[:,0], color='blue', label='Part (a): approx. sol.' )
    pylab.plot( T_a, Y_truth_a, color='green', label='Part (a): truth' )

    pylab.plot( T_b, Y_b[:,0], color='blue', label='Part (b): approx. sol.' )
    pylab.plot( T_b, Y_truth_b, color='green', label='Part (b): truth' )

    pylab.xlabel('t (time)'); pylab.ylabel('y(t)')
    pylab.grid('on')
    pylab.legend(loc='best')
    pylab.show() 
