#!/usr/bin/env python
#
# Problem EPage 
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, zeros
from run_kut5 import integrate
from printSoln import printSoln
import pylab 

def F(x,y): 
    # vector y is = [ y(t), y'(t) ]
    F = zeros( (2,), dtype=float ) 
    F[0] = y[1]
    F[1] = -y[1] + y[0]
    return F 

x0 = 0.0 # start of the integration 
xStop = 1.0 # end of the integration 
h = 0.1
freq = 0

y0 = asarray( [ 0., 1.349477 ], dtype=float ) 
X,Y = integrate(F,x0,y0,xStop,h) 
printSoln(X,Y,freq)

if True:
    pylab.plot( X, Y[:,0], color='black', label='approx. sol.' )
    pylab.xlabel('x'); pylab.ylabel('y(x)')
    pylab.grid('on')
    pylab.legend(loc='best')
    pylab.show() 
