#!/usr/bin/env python
#
# Problem EPage 362
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, sqrt, diag, dot

from stdForm import stdForm
from jacobi import jacobi 
from sortJacobi import sortJacobi 

A = asarray( [ [ 1.4, 0.8, 0.4 ], [ 0.8, 6.6, 0.8 ], [ 0.4, 0.8, 5.0 ] ], dtype=float ) 
B = asarray( [ [ 0.4, -0.1, 0.0 ], [ -0.1, 0.4, -0.1 ], [ 0.0, -0.1, 0.4 ] ], dtype=float ) 

H, T = stdForm(A.copy(),B.copy())
print "H= "
print H 
print "T= "
print T 

Lam, Z = jacobi(H.copy())
X = dot(T,Z) # eigenvalues of the original problem 
for jj in range(A.shape[1]): # normalize eigenvectors 
    xMag = sqrt(dot(X[:,jj],X[:,jj]))
    X[:,jj] /= xMag
sortJacobi(Lam,X) # arrange in ascending order
print "eigenvalues= ", Lam
print "eigenvectors= "
print X

if False:
    print "Checking Ax = lambda B x for our solution"
    print "A x= "
    print dot(A,X)
    print "lambda B x= "
    print np.tile( Lam, (B.shape[0],1) ) * dot(B,X)
    




