#!/usr/bin/env python
#
# Problem EPage 362
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, sqrt, diag, dot
from scipy.linalg import lu, inv, eig

from sortJacobi import sortJacobi

A = asarray( [ [ 6, -4, 1, 0 ], [ -4, 6, -4, 1 ], [ 1, -4, 6, -4 ], [ 0, 1, -4, 7 ] ], dtype=float ) 
B = asarray( [ [ 1, -2, 3, -1 ], [ -2, 6, -2, 3 ], [ 3, -2, 6, -2 ], [ -1, 3, -2, 9 ] ], dtype=float ) 

# Form the coefficient matrix for the standard form problem ( H z = lambda z ):
# 
L, U = lu(B,permute_l=True) # L here is really P L (the permutation matrix times L)
LInv = inv(L)
UInv = inv(U) 
H = dot(LInv,dot(A,UInv)) # note that H is not symmetric 

# Compute these eigenvalues/eigenvectors:
# 
W, VR = eig(H,right=True)
W = W.real # the eigenvalues are real but numerically they have a very small (zero) imaginary part 

# Convert these eigenvalues back into the original space:
# 
XR = dot(UInv,VR)
for jj in range(XR.shape[1]):
    xNorm = sqrt(dot(XR[:,jj],XR[:,jj]))
    XR[:,jj] /= xNorm 
sortJacobi(W,XR)
print "eigenvalues= "
print W 
print "eigenvectors= "
print XR 

if False:
    print "Checking Ax = lambda B x for our solution"
    AX = dot(A,XR) 
    print "A x= "
    print AX 
    LBX = np.tile( W, (B.shape[0],1) ) * dot(B,XR)
    print "lambda B x= "
    print LBX
    print np.linalg.norm( ( AX - LBX ).flatten() )




