#!/usr/bin/env python
#
# Problem EPage 362
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, sqrt, diag, dot, zeros, identity

from stdForm import stdForm
from jacobi import jacobi
from sortJacobi import sortJacobi

A = asarray( [ [ 2, -1, 0, 0 ], [ -1, 2, -1, 0 ], [ 0, -1, 2, -1 ], [ 0, 0, -1, 2 ] ], dtype=float ) 
B = asarray( [ [ 1, 0, 0, 0 ], [ 0, 2, 0, 0 ], [ 0, 0, 3, 0 ], [ 0, 0, 0, 4 ] ] , dtype=float ) 

# Convert our eigenvalue problem to standard form:
# 
H, T = stdForm(A.copy(),B.copy())
if False:
    print "H= "
    print H 
    print "T= "
    print T 

Lam, Z = jacobi(H.copy())
X = dot(T,Z) # eigenvalues of the original problem 
for jj in range(X.shape[1]): # normalize eigenvectors 
    xMag = sqrt(dot(X[:,jj],X[:,jj]))
    X[:,jj] /= xMag
sortJacobi(Lam,X) # arrange in ascending order
print "eigenvalues= ", Lam
print "eigenvectors= "
print X

if False:
    print "Checking Ax = lambda B x for our solution"
    print "A x= "
    AX = dot(A,X) 
    print AX
    print "lambda B x= "
    LBX = np.tile( Lam, (B.shape[0],1) ) * dot(B,X)
    print LBX
    print "||A X - lambda B X||= ", np.linalg.norm( ( AX - LBX ).flatten() )
