#!/usr/bin/env python
#
# Problem EPage 
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, dot, sqrt

from lamRange import lamRange
from householder import householder, computeP
from eigenvals3 import eigenvals3
from inversePower3 import inversePower3

A_orig = asarray( [ [  7, -4,  3, -2,  1,  0 ], 
                    [ -4,  8, -4,  3, -2,  1 ], 
                    [  3, -4,  9, -4,  3, -2 ], 
                    [ -2,  3, -4, 10, -4,  3 ], 
                    [  1, -2,  3, -4, 11, -4 ], 
                    [  0,  1, -2,  3, -4, 12 ] ], dtype=float ) 
A = A_orig.copy() 

d, c = householder( A ) 
print "diagonal d= "
print d
print "subdiagonal c= "
print c
print "transformation matrix P="
P = computeP(A)
print P

lowest_three_evalues = eigenvals3(d,c,3)
print "lowest_three_evalues= ", lowest_three_evalues

# Extract the eigenvector of the lowest eigenvalue:
# 
lam_1, v_1 = inversePower3(d,c,lowest_three_evalues[0])
x_1 = dot(P,v_1) # transform back to the original coordinates 
x_1 /= sqrt(dot(x_1,x_1))
print "eigenvector of lowest eigenvalue= ", x_1

if False: 
    print "Verify that we can transform A into the tridiagonal form given above using P: "
    print dot(dot(P.T,A_orig),P)

    print "Verify that we have found an eigenvector of the original problem"
    AX = dot(A_orig,x_1)
    LX = lowest_three_evalues[0] * x_1 
    print np.linalg.norm( AX - LX )
